题解 P3146 【[USACO16OPEN]248】

· · 题解

区间DP

又是令人头痛的DP

其实这道题并不是很难啊,只要把转移方程推出来就好了。

我们用 dp[i][j] 表示区间 i到j 可以合成的最大数。 那么可以得到

if (dp[i][k]==dp[k+1][j]) dp[i][j]=max(dp[i][j],dp[i][k]+1)

那么只需要先枚举结点,在以该结点为中心向两边枚举长度即可,但一次循环不能保证所有数据都正确,因为后得出的区间可能更新前得出的区间。

所以多次循环即可。

打上代码

#include<bits/stdc++.h>
using namespace std;
int n,dp[250][250];
int main()
{
    cin>>n;
    int ans=0;
    for(int i=1;i<=n;i++)
    {
       cin>>dp[i][i];
       ans=max(ans,dp[i][i]);
    }
    for (int i=n-1;i>=1;i--)
        for (int j=i+1;j<=n;j++)
        {
            for (int k=i;k<j;k++)
                if (dp[i][k]==dp[k+1][j])
                    dp[i][j]=max(dp[i][j],dp[i][k]+1);
            ans=max(ans,dp[i][j]);
        }
    cout<<ans<<endl;
    return 0;
}